;***********************************;
; Ping Pong! by Leigh Prosho        ;
; v1.0 Started 21/9/01              ;
; v1.0 Finished 22/9/01             ;
; v1.0 - basic 2 player pong game   ;
; v1.1 Started 23/9/01              ;
; v1.1 Finished ??/??/??            ;
; v1.1 - include single player mode ;
;***********************************;

; Set display mode values
Const width=640,height=480

; Set screen size
Graphics width,height

; Draw to back buffer
SetBuffer BackBuffer()

; Load GFX & SFX into memory

	; Load Graphics files

	Global background=LoadImage("gfx\background.bmp")
	Global wall=LoadImage("gfx\wall.bmp")
	Global bat1=LoadImage("gfx\bat1.bmp")
	Global bat2=LoadImage("gfx\bat2.bmp")
	Global ball=LoadImage("gfx\ball.bmp")
	Global instructions=LoadImage("gfx\instructions.bmp")
	Global logo=LoadImage("gfx\logo.bmp")
	Global play=LoadImage("gfx\s2play.bmp")

	; Load beep sounds
	beep1=LoadSound("sfx/beep.wav")
	beep2=LoadSound("sfx/beeplow.wav")

; Load Global Game variables & Constants

	; initialise number of players (default is 2)
	
	Global players=0
	
	; Initialise scores

	Global player1score=0
	Global player2score=0

	; Setup Keyboard Constants

	Const p1up=30, p1down=44
	Const p2up=37, p2down=50
	Const space=57, esc=1
	Const ret=28
	
; Set initial bat & ball start positions

	; Set Player 1 bat position
	Global bat1x=width-632
	Global bat1y=(height/2)-32

	; Set Player 2 bat position
	Global bat2x=width-16
	Global bat2y=(height/2)-32
	
    ; Set ball start position
	Global ballx=width/2
	Global bally=height/2
	Global ballydir=Rnd(1,4)
	Global ballxdir=Rnd(1,4)

;;;;;;;;;
; Intro ;
;;;;;;;;;

.intro

While players=0

	; Clear the screen
	Cls

  	; Draw background
  	DrawImage(background,0,0)
	MidHandle logo
	DrawImage(logo,width/2,50)

	; Ask how many players
  	Text(12,height/4,"How many players? (1 or 2)")
    If KeyDown(2) Then players=1
    If KeyDown(3) Then players=2

	; Swap buffers
  	Flip

	; Check to see if key pressed is Escape, and if so quits game
    If KeyDown(esc) Then End

Wend

While Not KeyDown(space)

  	; Display number of players
  	Text(12,height/3,"Number of players selected ="+players)
  	Text(12,height/2.5,"Please press the SPACE key to play, or the I key for instructions")

  	; Swap buffer
  	Flip

  	; Check to see if I pressed
  	If KeyDown(23) Then instructions()

	; Check to see if key pressed is Escape, and if so quits game
    If KeyDown(esc) Then End

Wend
;;;;;;;;;;;;;;;;;;;
; Start Game Loop ;
;;;;;;;;;;;;;;;;;;;

.startgame

While Not KeyDown(ret)

     ; Clear the screen
     Cls

     ; Draw background
     DrawImage(background,0,0)

     ; Draw Playfield
     DrawImage(wall,0,32)
     DrawImage(wall,0,480-32)

     ; Display Scores
     showscore()

	; Set Player 1 bat position
	bat1x=width-632
	bat1y=(height/2)-32

	; Set Player 2 bat position
	bat2x=width-16
	bat2y=(height/2)-32

     ; Set ball start position
	 ballx=width/2
	 bally=height/2
	 ballydir=Rnd(1,4)
 	 ballxdir=Rnd(1,4)

	If ballydir=3 Then ballydir=-1
	If ballydir=4 Then ballydir=-2
	If ballxdir=2 Then ballxdir=-1
	If ballxdir=4 Then ballxdir=-2	
	
     ; Draw bats & ball
     DrawImage(bat1,bat1x,bat1y)
     DrawImage(bat2,bat2x,bat2y)
     DrawImage(ball,ballx,bally)

	; Check playerscores, if score = 10, the goes to endgame
	If player1score=10 Or player2score=10
	   Goto endgame
	EndIf

	; Display start message
	Text((width/4)+40,16,"Press RETURN to start game")

	; swap buffers
	Flip
	
	; Check to see if key pressed is Escape, and if so quits game
    If KeyDown(esc) Then End

; Loop until player hits thge Return key
Wend

;;;;;;;;;;;;;;;;;;
; Main Game Loop ;
;;;;;;;;;;;;;;;;;;

.maingame

While Not KeyDown(esc)

	; Clear the screen
	Cls

	; Draw background
	DrawImage(background,0,0)

	; Draw Playfield
	DrawImage(wall,0,32)
	DrawImage(wall,0,480-32)

	; Display Scores
	showscore()

	; Draw bats & ball
	DrawImage(bat1,bat1x,bat1y)
	DrawImage(bat2,bat2x,bat2y)
	DrawImage(ball,ballx,bally)

	; Move Player 1 bat
	bat1y=bat1y+(KeyDown(p1down)-KeyDown(p1up))*3
	
	; Move Player 2 bat
	If players =1 And bally>bat2y And ballxdir>=1 Then bat2y=bat2y+1*Rnd(1,3)
	If players =1 And bally<bat2y And ballxdir>=1 Then bat2y=bat2y-1*Rnd(1,3)
	If players =2 Then bat2y=bat2y+(KeyDown(p2down)-KeyDown(p2up))*3
	
	; Update ball position
	ballx=ballx+ballxdir
    ballY=bally+ballydir

	; If bat image collides with wall
	If ImagesCollide(bat1,bat1x,bat1y,0,wall,0,32,0) Then bat1y=48
	If ImagesCollide(bat1,bat1x,bat1y,0,wall,0,height-32,0) Then bat1y=height-96
	If ImagesCollide(bat2,bat2x,bat2y,0,wall,0,32,0) Then bat2y=48
	If ImagesCollide(bat2,bat2x,bat2y,0,wall,0,height-32,0) Then bat2y=height-96

	; If ball image collides with either bat image then alter x ball movement value and play beep sound
	If ImagesCollide(ball,ballx,bally,0,bat1,bat1x,bat1y,0) Then ballxdir=Rnd(1,4) : PlaySound beep2
	If ImagesCollide(ball,ballx,bally,0,bat2,bat2x,bat2y,0) Then ballxdir=Rnd(1,4)*-1 : PlaySound beep2
	
	; If ball image collides with play area wall then alter y ball movement value and play beep sound
	If ImagesCollide(ball,ballx,bally,0,wall,0,32,0) Then ballydir=Rnd(1,4) : PlaySound beep1   
	If ImagesCollide(ball,ballx,bally,0,wall,0,480-32,0) Then ballydir=Rnd(1,4)*-1 : PlaySound beep1 
	
	; If ball gets past player 2 bat,increase player 1 score, display a "win" message & restart game
	If ballx>=640
	   player1score=player1score+1
	   Text((width/4)+40,16,"Player 1 scores a point!")
	   Flip
	   Delay 1500
	   Goto startgame
	EndIf
	
	; If ball gets past player 2 bat,increase player 1 score, display a "win" message & restart game
	If ballx<=0
	   player2score=player2score+1
	   Text((width/4)+40,16,"Player 2 scores a point!")
	   Flip
	   Delay 1500
	   Goto startgame
	EndIf
	
	; swap buffers
	Flip

; loop until player hits the ESCAPE key 
Wend

; End program, back to Windows
End

;;;;;;;;;;;;;;;;
; Endgame Loop ;
;;;;;;;;;;;;;;;;

.endgame
While Not KeyDown(esc)

	; Clear the screen
    Cls

    ; Draw background
    DrawImage(background,0,0)

    ; Draw Playfield
    DrawImage(wall,0,32)
    DrawImage(wall,0,480-32)

    ; Display Scores
    showscore()

	; Checks Player 1 score, and displays a win message
	If player1score=10
	   Text((width/3)+40,16,"Player 1 Wins!")
	EndIf

	; Checks Player 2 score, and displays a win message	
	If player2score=10
	   Text((width/3)+40,16,"Player 2 Wins!")
	EndIf

	; Asks if another game is to be played
	Text(width/4, height/2,"Would you like another game? (Y / N)")
	Flip
	
	; Checks if Y key is pressed, if so resets scores and number of players, and goes to intro
	If KeyDown(21)
	   player1score=0
	   player2score=0
	   players=0
	   Goto intro
	EndIf
	
	; Checks if N key is pressed, if so quits to Windows
	If KeyDown(49)
	   End
	EndIf

; Loop until player hits the ESCAPE key	
Wend


;;;;;;;;;;;;;;;;
;Game Functions;
;;;;;;;;;;;;;;;;

; This function displays the score on the screen

Function showscore()
	
	Text(24,0,"Player 1 Score = "+player1score)
	Text(435,0," Player 2 Score = "+player2score)

End Function

Function instructions()

Repeat

  ; Clear the screen
  Cls

  ; Display Instructions
  MidHandle instructions  
  MidHandle logo
  MidHandle play
  DrawImage(background,0,0)
  DrawImage(logo,width/2,50)
  DrawImage(instructions,width/2,height/2)
  DrawImage(play,width/2,430)

  ; swap buffers
  Flip

  ; loop until you hit escape.  
Until KeyDown(space)

End Function